;02-2005 LZ4GV
;PIC16F88-I/P	INTRC_OSC   8MHz
;GSM Siemens C35/C45
;Ver.49

	list		p=16F88		; list directive to define processor
	#include	<p16F88.inc>	; processor specific variable definitions

;Program Configuration Register 1
	__CONFIG    _CONFIG1, _INTRC_IO & _CP_OFF & _CPD_OFF & _BODEN_ON & _CCP1_RB3 & _MCLR_OFF & _DEBUG_OFF & _WRT_PROTECT_OFF & _LVP_OFF & _PWRTE_ON & _WDT_OFF

;Program Configuration Register 2
	__CONFIG    _CONFIG2, _IESO_OFF & _FCMEN_OFF

OSCTUNE_MNL	EQU	.0	;Central frequency	min .32 - .63  0  .1 - .31 max

#define	RA0		PORTA,0	;Analog Input: +Battery
#define	INPUT1		PORTA,1	;Input:
#define	BEEP		PORTA,2	;Output: Beep
#define	RA3		PORTA,3
#define	PWR_CLS		PORTA,4	;Output: Button 'PowerON/Close'
#define	MANU_ONOFF	PORTA,5	;Input:     1-/0-  
#define	PWR_CNF		PORTA,6	;Output:     C45.
#define	POWER_GPS	PORTA,7	;Output:   GPS

#define	POWER_SUPPLY	PORTB,0	;Output:    GSM,GPS
#define	OUT1		PORTB,1	;Output:  1
;			PORTB,2	;Input:  RX UART <- TXData GSM
#define	RX		PORTB,3	;Input:  NMEA-0183 9600bps ASCII
#define	TX		PORTB,4	;Output: SiRF	9600bps/38400bps
;			PORTB,5	;Output: TX UART -> RXData GSM
#define	SCL		PORTB,6	;Output: Clock LCD
#define	SDA		PORTB,7	;Output: Data  LCD


#define	WORK_OK		0x20,0	;
#define	SOFT_RX_ERR	0x20,1	;1 -      .
#define	SOFT_RX_END	0x20,2	;1 -   .
#define	STAT_MANU_ONOFF	0x20,3	;
#define	RXBUF_PROTECT	0x20,4	;
#define	GSM_NoAnswer	0x20,5	;1 -           15S.
#define	GSM_ErrData	0x20,6	;1 -      .

#define	GPSSpeedBIT	0x21,0	;
#define	LatLngBIT	0x21,1	;

ASCII_1		EQU	0x22	; ASCII <=> PDU.
ASCII_2		EQU	0x23	;
ASCII_3		EQU	0x24	;
ASCII_4		EQU	0x25	;
ASCII_5		EQU	0x26	;
ASCII_6		EQU	0x27	;
ASCII_7		EQU	0x28	;
ASCII_8		EQU	0x29	;

NUM_1		EQU	0x2A	;   GSM     .
NUM_2		EQU	0x2B
NUM_3		EQU	0x2C
NUM_4		EQU	0x2D
NUM_5		EQU	0x2E
NUM_6		EQU	0x2F
NUM_7		EQU	0x30
NUM_8		EQU	0x31
NUM_9		EQU	0x32
NUM_10		EQU	0x33
NUM_11		EQU	0x34
NUM_12		EQU	0x35
TYPE_CALL	EQU	0x36
TYPE_ANSWER	EQU	0x37	;

RSSIH		EQU	0x38
RSSIL		EQU	0x39

CELLH		EQU	0x3A
CELLL		EQU	0x3B

SMS_COUNT	EQU	0x3C	;SMS
COUNT_ANSWER	EQU	0x3D


;**********************************************************************
HEX1		EQU	0x40	;   HEX->DEC.
HEX2		EQU	0x41	;-//-
HEX3		EQU	0x42	;
HEX4		EQU	0x43	;FFFFFFFFh=.4294967295
DEC1		EQU	0x44	;
DEC2		EQU	0x45	;
DEC3		EQU	0x46	;
DEC4		EQU	0x47	;
DEC5		EQU	0x48	;
DEC6		EQU	0x49	;
DEC7		EQU	0x4A	;
DEC8		EQU	0x4B	;
DEC9		EQU	0x4C	;
DEC10		EQU	0x4D	;
;COUNT		EQU	0x	;  HEX->DEC.
;COUNT1		EQU	0x	;-//-
;**********************************************************************

;**********************************************************************
;HEX1		EQU	0x	;   ASCII->HEX.
;HEX2		EQU	0x	;-//-
;DEC1		EQU	0x	;
;DEC2		EQU	0x	;
;DEC3		EQU	0x	;
;DEC4		EQU	0x	;
;DEC5		EQU	0x	;
;**********************************************************************

;**********************************************************************
;HEX4		EQU	0x
;HEX3		EQU	0x
;HEX2		EQU	0x
;HEX1		EQU	0x
HEXmul4		EQU	0x56
HEXmul3		EQU	0x57
HEXmul2		EQU	0x58
HEXmul1		EQU	0x59
MUL_REG_4	EQU	0x4E	; 
MUL_REG_3	EQU	0x4F
MUL_REG_2	EQU	0x50
MUL_REG_1	EQU	0x51
;COUNT		EQU	0x
;**********************************************************************

;**********************************************************************
;HEX4		EQU	0x	;  .
;HEX3		EQU	0x
;HEX2		EQU	0x
;HEX1		EQU	0x
HEX4ADD		EQU	0x4E
HEX3ADD		EQU	0x4F
HEX2ADD		EQU	0x50
HEX1ADD		EQU	0x51
;COUNT		EQU	0x
;**********************************************************************

;**********************************************************************
;HEX4		EQU	0x
;HEX3		EQU	0x
;HEX2		EQU	0x
;HEX1		EQU	0x
RESULT4		EQU	0x52
RESULT3		EQU	0x53
RESULT2		EQU	0x54
RESULT1		EQU	0x55
HEXdel_4	EQU	0x56
HEXdel_3	EQU	0x57
HEXdel_2	EQU	0x58
HEXdel_1	EQU	0x59
DIV_REG_4	EQU	0x4E	; 
DIV_REG_3	EQU	0x4F
DIV_REG_2	EQU	0x50
DIV_REG_1	EQU	0x51
;COUNT		EQU	0x
;**********************************************************************

COUNT		EQU	0x5A	;hex->dec, beeper, uart
COUNT1		EQU	0x5B	;hex->dec, beeper
COUNT2		EQU	0x5C	;
COUNT_UAR	EQU	0x5D	;uart
BYTE_UART	EQU	0x5E	;uart
CHSUM		EQU	0x5F	;
CHSUMMEM	EQU	0x60

EE_MEM		EQU	0x61

COUNT_NMEA	EQU	0x62


PCLMEM		EQU	0x73	;
OPTIONMEM	EQU	0x74	;
FSRMEM		EQU	0x75	;
ACQT		EQU	0x76	;
TMR0MEM		EQU	0x77	;
TMR1LMEM	EQU	0x78	;
TMR1HMEM	EQU	0x79	;
INTCONMEM	EQU	0x7A	;0x70 to 0x7F	Bank 0,1,2,3
REEADR		EQU	0x7B	;-//-
REEDATA		EQU	0x7D	;-//-
W_TEMP		EQU	0x7E	;-//-
STATUS_TEMP	EQU	0x7F	;-//-

;**********************************************************************
#define	StartGPS	0xA0	;0xA0 to 0xEF	Bank 1	   GPS  ASCII .
#define	Name		D'1'	;8 byte	XX9999XX
#define Icon		D'9'	;1 byte	;C - Car1 or
#define	GPStat		D'10'	;1 byte	A or
#define	GPLat		D'11'	;9 byte	4312.7746
#define GPLatNS		D'20'	;1 byte	N or S
#define GPLng		D'21'	;10byte	02755.7226
#define GPLngEW		D'31'	;1 byte	E or W
#define GPTime		D'32'	;6 byte	080955
#define GPData		D'38'	;6 byte	220908
#define	GPSpeed		D'44'	;3 byte	001 knot
#define	GPHeading	D'47'	;3 byte	123 deg
#define	Reserv		D'50'	;6 byte	Reserve
#define	LengthGPS	D'56'	; 56 byte  RAM.
;**********************************************************************

StartAdrUART	EQU	0x110	;Start Address RAM.
EndAdrUART	EQU	0x16F	;End Address RAM.


#define	WPAGE		PCLATH,3	;0- Work. Page0		1- Work. Page1
#define	FSRBANK		STATUS,IRP	;0- Bank0,1		1- Bank2,3	    FSR.
LF		EQU	0x0A
CR		EQU	0x0D


EE_InEnable1	EQU	0x2100	;1 byte
EE_Output1	EQU	0x2108	;1 byte
EE_PowerGPS	EQU	0x2110	;1 byte
EE_AlarmTime	EQU	0x2111	;1 byte
EE_TELNUM1	EQU	0x2120	;12 byte
EE_TELNUM2	EQU	0x2130	;12 byte
EE_TELNUM3	EQU	0x2140	;12 byte
EE_SMSCENT	EQU	0x2150	;12 byte

LowBatt_OFF	EQU	.60	;   -  6V.
LowBatt_ON	EQU	.70	;   -  7V.


	ORG	EE_InEnable1	;Initialize EEPROM locations
	DE	A'e'		;Enable/Disable

	ORG	EE_Output1	;Output 1
	DE	A'd'		;Active/Deactive

	ORG	EE_PowerGPS	;Power GPS
	DE	A'e'		;Active/Deactive

	ORG	EE_AlarmTime	;      . 
	DE	A'd'		; - 25S	d - 

	ORG	EE_TELNUM1	;
	DE	0x33,0x35,0x39,0x38,0x38,0x30,0x30,0x30,0x30,0x30,0x30,0x30

	ORG	EE_TELNUM2	;
	DE	0x33,0x35,0x39,0x38,0x38,0x30,0x30,0x30,0x30,0x30,0x30,0x30

	ORG	EE_TELNUM3	;
	DE	0x33,0x35,0x39,0x38,0x38,0x30,0x30,0x30,0x30,0x30,0x30,0x30

	ORG	EE_SMSCENT	;SMS Center
	DE	"35988000301F"	;M-Tel	+359 88 000 301
	;DE	"35989100000F"	;Globul	+359 89 100 000
	;DE	"359878000333"	;VivaCom+359 87 8000 333

	ORG	0x0000
	GOTO	START
	ORG	0x0004
	GOTO	START

;*******    ***************************
BEGIN
	bsf	WPAGE		;1- Work. Page1
	CALL	INI_GSM		;     GSM
	bcf	WPAGE		;Page0

	bcf	TX		;Output: SiRF	9600bps/38400bps
	bcf	POWER_GPS	;0 -    GPS.

	bcf	RCSTA,SPEN	;0 - Serial Port Disbled
	bcf	PORTB,5		;0 - TX to GSM

	bcf	POWER_SUPPLY	;0 -   .

	clrf	CELLH		; Cell ID
	clrf	CELLL		;

;*******     *************************
BEGIN1				;
	CALL	READC_RA0	;Out: F(ADRESH)	5V / 255 = 0,0196 * 5,1 = 0,1 V/dig

	MOVLW	LowBatt_ON	;7V
	SUBWF	ADRESH,W	;ADRESH > W	C=1
	BTFSS	STATUS,C	;ADRESH = W	C=1
	GOTO	BEGIN1		;ADRESH < W	C=0	--^
;**********************************************************************

	MOVLW	B'01110000'	;Internal oscillator	8MHz
	CALL	SET_OSC		;Oscillator configuration!

	MOVLW	.25		;19200 bps UART	8MHz
	CALL	SET_UART

	CALL	TIMER
	bsf	POWER_SUPPLY	;1 -    GSM.
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER

	movlw	.207		;
	CALL	BEEPER		;

;******* GSM ********************************************
BEGIN2
	BSF	WPAGE		;Page1 800h to FFFh
	CALL	GSM_SWITCH_ON	;Out: WORK_OK = 1 - GSM  .
	BCF	WPAGE		;Page0 000h to 7FFh
	BTFSS	WORK_OK		;
	GOTO	BEGIN2		;--^
;**********************************************************************

	movlw	.208		;
	CALL	BEEPER		;

;******* ''  GSM!****************************************
BEGIN3
	BSF	WPAGE		;
	CALL	ECHO_OFF	;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -         .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	BEGIN3		;--^
;**********************************************************************

	movlw	.209		;
	CALL	BEEPER		;

;*******   ***************************************
BEGIN5
	BSF	WPAGE		;
	CALL	SILENT		;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -         .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	BEGIN5		;--^
;**********************************************************************

	movlw	.210		;
	CALL	BEEPER		;

	CALL	TIMER		
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER

;*******        / C35  C45
BEGIN4				;   AT+CREG=2    !
	bsf	WPAGE		;1- Work. Page1
	CALL	CONFIG_CELLID	;       
	bcf	WPAGE		;Out: GSM_ErrData = 1 -   .
	btfsc	GSM_ErrData	;Out: GSM_NoAnswer = 1 -   .
	GOTO	NO_GSM		;Out: WORK_OK = 1 -  .
	btfsc	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	btfss	WORK_OK		;
	GOTO	BEGIN4		;--^
;**********************************************************************

	movlw	.211		;
	CALL	BEEPER		;

	MOVLW	.1
	MOVWF	SMS_COUNT
MAIN
;*******        GSM**************
	movlw	.1		;   .5
	SUBWF	SMS_COUNT,W	;
	btfss	STATUS,Z	;
	GOTO	MAIN_CID	;-->

	BSF	WPAGE		;
	CALL	READ_CELLID	;Out:F(CELLH,CELLL)
	BCF	WPAGE		;Out: WORK_OK = 1 -  .
	BTFSC	GSM_ErrData	;1 -         .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	NOP			;--^
MAIN_CID
;**********************************************************************

;**********************************************************************
	movlw	.1		;   .5
	SUBWF	SMS_COUNT,W	;
	btfss	STATUS,Z	;
	GOTO	MAIN_RSSI	;-->

	BSF	WPAGE		;
	CALL	RSSI		;    .
	BCF	WPAGE		;Out: F(RSSIH,RSSIL)
	BTFSC	GSM_ErrData	;Out: GSM_ErrData = 1 -      .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;Out: WORK_OK = 1 -  .
	GOTO	NO_GSM		;-->   'ERROR' !!!
MAIN_RSSI
;**********************************************************************

;*********        *********
	BSF	WPAGE		;
	CALL	RING_CHECK	;Out: WORK_OK = 1 - .
	BCF	WPAGE		;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6,NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
				;Out: F(TYPE_CALL)
	BTFSC	GSM_ErrData	;1 -         .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	MAIN_RCHK	; . -->

	MOVLW	A'0'		;Voice
	SUBWF	TYPE_CALL,W	;
	BTFSC	STATUS,Z	;
	GOTO	VOICE_CALL	;-->
	MOVLW	A'1'		;Data
	SUBWF	TYPE_CALL,W	;
	BTFSC	STATUS,Z	;
	GOTO	DATA_CALL	;-->
MAIN_RCHK
;**********************************************************************

;******* F(SMS_COUNT)   SMS *********************
	BSF	WPAGE		;In: F(SMS_COUNT)
	CALL	READ_SMS	;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6,NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	BCF	WPAGE		;Out: F(ASCII_1,ASCII_2,ASCII_3,ASCII_4,ASCII_5,ASCII_6,ASCII_7,ASCII_8)
	BTFSC	GSM_ErrData	;Out: GSM_ErrData = 1 -      .
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSC	WORK_OK		;Out: WORK_OK = 1 -   SMS.
	GOTO	SMS_CHECK	;-->

	MOVLW	.5		;  .9
	SUBWF	SMS_COUNT,W	;
	BTFSC	STATUS,C	;SMS_COUNT < W	C=0
	CLRF	SMS_COUNT	;SMS_COUNT >= W	C=1
	INCF	SMS_COUNT,F	;      SMS  1 - 5.
;**********************************************************************

;**********************************************************************
	MOVLW	EE_Output1	;    1.
	MOVWF	REEADR		;
	CALL	READE		;Active/Deactive
	SUBLW	A'e'		;'e' - .   .
	BTFSC	STATUS,Z	;
	bsf	OUT1		;1 -  .
	BTFSS	STATUS,Z	;
	bcf	OUT1		;0 -  .

	MOVLW	EE_PowerGPS	;   GPS.
	MOVWF	REEADR		;
	CALL	READE		;Active/Deactive
	SUBLW	A'd'		;'d' - .   .
	BTFSC	STATUS,Z	;
	BCF	POWER_GPS	;0 -    GPS.
	BTFSS	STATUS,Z	;
	BSF	POWER_GPS	;1 -    GPS.
	BTFSC	STATUS,Z	;
	BCF	TX		;Output: SiRF	9600bps/38400bps
	BTFSS	STATUS,Z	;
	BSF	TX		;Output: SiRF	9600bps/38400bps
;**********************************************************************

;**********************************************************************
	BTFSS	INPUT1		;  1 -  .
	GOTO	Input1_b	;-->

	MOVLW	EE_InEnable1	;   .
	MOVWF	REEADR		;
	CALL	READE		;
	SUBLW	A'e'		;'e' -  .
	BTFSS	STATUS,Z	;
	GOTO	Input1_b	;-->

	movlw	EE_AlarmTime
	movwf	REEADR		;
	CALL	READE		;
	sublw	A'e'		;
	btfss	STATUS,Z	;
	movlw	.1		;'d'
	btfsc	STATUS,Z	;
	movlw	.50		;'e' -  25S    .
	movwf	COUNT2		;
Input1_a
	MOVLW	EE_InEnable1	;In: W(    EEPROM)
	CALL	MANUAL_ACTIV	;    .

	MOVLW	EE_InEnable1	;   .
	MOVWF	REEADR		;
	CALL	READE		;
	SUBLW	A'd'		;'d' -  .
	BTFSC	STATUS,Z	;
	GOTO	Input1_b	;-->

	CALL	TIMER		;0,5S
	decfsz	COUNT2,F	;
	GOTO	Input1_a	;--^
	GOTO	RELEASE		;Alarm Active
Input1_b
;**********************************************************************

;**********************************************************************
	MOVLW	EE_InEnable1	;In: W(    EEPROM)
	CALL	MANUAL_ACTIV	;    .
;**********************************************************************

;*****************  **********************
	CALL	READC_RA0	;Out: F(ADRESH)	5V / 255 = 0,0196 * 5,1 = 0,1 V/dig

	MOVLW	LowBatt_OFF	; < 6V
	SUBWF	ADRESH,W	;ADRESH > W	C=1
	BTFSS	STATUS,C	;ADRESH = W	C=1
	GOTO	LOW_BATT	;ADRESH < W	C=0

	GOTO	MAIN		;    ! ---^
;

LOW_BATT
	BSF	WPAGE		;
	CALL	KEY_UNLOCK	; .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;Out: GSM_ErrData = 1 -   .
	GOTO	NO_GSM		;-->	
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->		
	BTFSS	WORK_OK		;Out: WORK_OK = 1 -  .
	NOP			;

LOW_BATT_1
	BSF	WPAGE		;
	CALL	GSM_SWITCH_OFF	; GSM .
	BCF	WPAGE		;
	BTFSS	WORK_OK		;Out: WORK_OK = 1 - GSM  .
	GOTO	LOW_BATT_1	;

	MOVLW	B'00000000'	;Internal oscillator	31,25KHz
	CALL	SET_OSC		;Oscillator configuration!

	GOTO	BEGIN		;---^
;**********************************************************************

;************************   *********************



;**********************************************************************
MANUAL_ACTIV			;    .
	MOVWF	REEADR		;In: W(    EEPROM)
				;
	BTFSS	MANU_ONOFF	;         MANU_ONOFF.
	GOTO	IN_OFF		;->
	GOTO	IN_ON		;->
;

IN_OFF
	BTFSS	STAT_MANU_ONOFF
	RETURN
	BCF	STAT_MANU_ONOFF	;   .

	MOVLW	.204		;  .
	CALL	BEEPER		;

	CALL	TIMER		;0,5S	Use TMR1

	MOVLW	.204		;  .
	CALL	BEEPER		;

	CALL	TIMER		;0,5S	Use TMR1

	MOVLW	.204		;  .
	CALL	BEEPER		;

	MOVLW	A'd'		;'d' -  .
	MOVWF	REEDATA
	CALL	WRITE

	RETURN
;

IN_ON
	BTFSC	STAT_MANU_ONOFF
	RETURN
	BSF	STAT_MANU_ONOFF	;   .

	MOVLW	.120		; 1min          .
	MOVWF	COUNT		;
IN_ON_1				;
	BTFSS	MANU_ONOFF	;
	GOTO	IN_OFF		;-->

	CALL	TIMER		;0,5S	Use TMR1
	DECFSZ	COUNT,F		;
	GOTO	IN_ON_1		;

	MOVLW	.205		;  .
	CALL	BEEPER		;

	CALL	TIMER		;0,5S	Use TMR1

	MOVLW	.206		;  .
	CALL	BEEPER		;

	CALL	TIMER		;0,5S	Use TMR1

	MOVLW	.207		;  .
	CALL	BEEPER		;

	CALL	TIMER		;0,5S	Use TMR1

	MOVLW	.208		;  .
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;

	MOVLW	A'e'		;'e' -  .
	MOVWF	REEDATA		;
	CALL	WRITE		;

	RETURN			;
;**********************************************************************


;**********************************************************************
SMS_CHECK
;------------- F(SMS_COUNT)   SMS ---------------
SMS_DEL
	BSF	WPAGE		;
	CALL	DELITE_SMS	;In: F(SMS_COUNT)
	BCF	WPAGE		;Out: WORK_OK = 1 -  .
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	SMS_DEL		;--^
;----------------------------------------------------------------------

	BSF	ASCII_1,5	;  /  ->   !
	BSF	ASCII_2,5	;  !
	BSF	ASCII_3,5
	BSF	ASCII_4,5
	BSF	ASCII_5,5
	BSF	ASCII_6,5
	BSF	ASCII_7,5
	BSF	ASCII_8,5

	MOVF	ASCII_1,W	; .
	SUBLW	A'g'		;'Gps'
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_GPS	;-->

	MOVF	ASCII_1,W
	SUBLW	A'b'		;'Bee'
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_BEE	;-->

	MOVLW	EE_TELNUM1	;     .
	MOVWF	EE_MEM		;
	CALL	CHECK_NUM	;In: W (start address EEPROM)
	BTFSC	WORK_OK		;Out: WORK_OK = 1 -  
	GOTO	SMS_CHECK1	;-->

	MOVLW	EE_TELNUM2	;     .
	MOVWF	EE_MEM		;
	CALL	CHECK_NUM	;In: W (start address EEPROM)
	BTFSC	WORK_OK		;Out: WORK_OK = 1 -  
	GOTO	SMS_CHECK1	;-->

	MOVLW	EE_TELNUM3	;     .
	MOVWF	EE_MEM		;
	CALL	CHECK_NUM	;In: W (start address EEPROM)
	BTFSC	WORK_OK		;Out: WORK_OK = 1 -  
	GOTO	SMS_CHECK1	;-->

	GOTO	MAIN		;--^

SMS_CHECK1
	MOVF	ASCII_1,W
	SUBLW	A'i'		;'InXY'
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_IN	;-->

	MOVF	ASCII_1,W
	SUBLW	A'o'		;'OutXY'
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_OUT	;-->

	GOTO	MAIN		;---^
;

SMS_CHECK_GPS
	MOVF	ASCII_2,W
	SUBLW	A'p'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	MOVF	ASCII_3,W
	SUBLW	A's'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	GOTO	SEND_NMEA	;-->
;

SMS_CHECK_BEE
	MOVF	ASCII_2,W
	SUBLW	A'e'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	MOVF	ASCII_3,W
	SUBLW	A'e'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	MOVF	ASCII_4,W
	SUBLW	A'1'
	MOVLW	EE_TELNUM1	;
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_BEE1	;-->	In: W (start address EEPROM)

	MOVF	ASCII_4,W
	SUBLW	A'2'
	MOVLW	EE_TELNUM2	;
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_BEE1	;-->	In: W (start address EEPROM)

	MOVF	ASCII_4,W
	SUBLW	A'3'
	MOVLW	EE_TELNUM3	;
	BTFSC	STATUS,Z
	GOTO	SMS_CHECK_BEE1	;--> In: W (start address EEPROM)

	GOTO	MAIN		;---^	 .

SMS_CHECK_BEE1
	MOVWF	EE_MEM		;        SMS.	
	CALL	WRITE_NUM	;In: W (start address EEPROM)

	CALL	TIMER		;

	bsf	WPAGE		;1- Work. Page1
	CALL	SMS_CENTER	; SMS Survice Center       SMS.
	bcf	WPAGE		;Page0
	btfsc	GSM_ErrData	;Out: EEPROM <GSM_ErrData><GSM_NoAnswer><WORK_OK>
	GOTO	NO_GSM		;WORK_OK = 1 -   Service Center  EEPROM.
	btfsc	GSM_NoAnswer	;
	GOTO	NO_GSM		;
	

	CALL	TIMER		;
	MOVF	EE_MEM,W	;
	GOTO	CONFIRM		;In: W	    .
;

;***
SMS_CHECK_IN
	MOVF	ASCII_2,W
	SUBLW	A'n'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	movf	ASCII_3,W	;  
	sublw	A't'
	movlw	EE_AlarmTime	;'e' - 	'd' -  
	btfsc	STATUS,Z
	GOTO	SMS_CHECK_IN_END;.

	movf	ASCII_3,W	;  .
	sublw	A'1'
	movlw	EE_InEnable1	;'e' -     'd' -  
	btfsc	STATUS,Z
	GOTO	SMS_CHECK_IN_END

	GOTO	MAIN		;---^	 .

SMS_CHECK_IN_END
	movwf	REEADR
	movf	ASCII_4,W	
	movwf	REEDATA
	CALL	WRITE

	CALL	TIMER		;
	MOVF	EE_MEM,W	;
	GOTO	CONFIRM		;In: W	    .
;***

;***
SMS_CHECK_OUT
	MOVF	ASCII_2,W
	SUBLW	A'u'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	MOVF	ASCII_3,W
	SUBLW	A't'
	BTFSS	STATUS,Z
	GOTO	MAIN		;---^	 .

	MOVWF	REEADR
	movf	ASCII_4,W	;  I/O.
	sublw	A'1'
	movlw	EE_Output1	;       
	btfsc	STATUS,Z
	GOTO	SMS_CHECK_OUT_END;->

	movf	ASCII_4,W	;  I/O.
	sublw	A'g'		;
	movlw	EE_PowerGPS	;
	btfsc	STATUS,Z	;
	GOTO	SMS_CHECK_OUT_END;->

	GOTO	MAIN		;---^
;

SMS_CHECK_OUT_END
	movwf	REEADR		;
	movf	ASCII_5,W	;'a' -  .
	movwf	REEDATA		;
	CALL	WRITE		;

	CALL	TIMER		;
	MOVF	EE_MEM,W	;
	GOTO	CONFIRM		;In: W	    .
;**********************************************************************

;*****************   GSM**************************
VOICE_CALL
	MOVLW	EE_TELNUM1	;       .
	CALL	CHECK_NUM	;In: W (start address EEPROM)
	BTFSC	WORK_OK		;Out: WORK_OK = 1 -  
	GOTO	VOICE_CALL1	;-->

	MOVLW	EE_TELNUM2	;
	CALL	CHECK_NUM	;
	BTFSC	WORK_OK		;
	GOTO	VOICE_CALL1	;-->

	MOVLW	EE_TELNUM3	;
	CALL	CHECK_NUM	;
	BTFSC	WORK_OK		;
	GOTO	VOICE_CALL1	;-->

	GOTO	VOICE_DISCONNECT

VOICE_CALL1
	BSF	WPAGE		;
	CALL	VOICE_CONNECT	;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	VOICE_DISCONNECT;-->

	BSF	RCSTA,CREN	;@   .
VOICE_CALL2			;
	BTFSC	PIR1,RCIF	;@     GSM. <CR><LF>NO_CARRIER<CR><LF>
	GOTO	DATA_DISCONNECT	;@ -->  !
	GOTO	VOICE_CALL2	;--^

VOICE_DISCONNECT
	MOVF	RCREG,W		;@   .
	BCF	RCSTA,CREN	;@   .

	BSF	WPAGE		;
	CALL	DISCONNECT
	BCF	WPAGE		;

	GOTO	MAIN		;
;***********************************************************************

;***********   GSM***********************************
DATA_CALL
	BSF	POWER_GPS	;1 -    GPS   .
	BSF	TX		;Output: SiRF	9600bps/38400bps

	BSF	WPAGE		;      
	CALL	KEY_UNLOCK	;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	;BTFSS	WORK_OK		;
	;GOTO	DATA_CALL	;--^

	BSF	WPAGE		;
	CALL	DATA_CONNECT	;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	DATA_DISCONNECT	;-->       .
;

	BSF	STATUS,RP0	;
	MOVF	OPTION_REG,W	;   OPTION_REG
	MOVWF	OPTIONMEM	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	IORLW	B'00000001'	;38400bps	8MHz
	;IORLW	B'00000011'	; 9600bps	8MHz
	MOVWF	OPTION_REG	;
	BCF	STATUS,RP0	;

	bsf	WPAGE		;
	bcf	GPSSpeedBIT	;1-   GPS      38400 bps	0 - 9600 bps
	CALL	GPS_SPEED	;   GPS  38400bps  9600bps
	bcf	WPAGE		;
;

	BSF	STATUS,RP0	;    UART
	MOVF	OPTION_REG,W	;   OPTION_REG
	MOVWF	OPTIONMEM	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	;IORLW	B'00000001'	;38400bps	8MHz
	IORLW	B'00000011'	; 9600bps	8MHz
	MOVWF	OPTION_REG	;
	BCF	STATUS,RP0	;

	BSF	RCSTA,CREN	;@     GPS.
;
	clrf	HEX4
	CLRF	HEX3		;            .
	MOVF	CELLH,W		;
	MOVWF	HEX2		;
	MOVF	CELLL,W		;
	MOVWF	HEX1		;
	bsf	WPAGE		;
	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
	;bcf	WPAGE		;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	;bsf	WPAGE		;Page1 800h to FFFh
	MOVLW	0x0D		
	CALL	UAT
	MOVLW	0x0A
	CALL	UAT
	MOVLW	A'C'
	CALL	UAT
	MOVLW	A'e'
	CALL	UAT
	MOVLW	A'l'
	CALL	UAT
	MOVLW	A'l'
	CALL	UAT
	MOVLW	A'I'
	CALL	UAT
	MOVLW	A'D'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT
	MOVF	DEC5,W
	CALL	UAT
	MOVF	DEC4,W
	CALL	UAT
	MOVF	DEC3,W
	CALL	UAT
	MOVF	DEC2,W
	CALL	UAT
	MOVF	DEC1,W
	CALL	UAT
	MOVLW	0x0D
	CALL	UAT
	MOVLW	0x0A
	CALL	UAT
	BCF	WPAGE		;Page0 000h to 7FFh
;

	BSF	WPAGE		;Page1 800h to FFFh
	MOVLW	A'R'
	CALL	UAT
	MOVLW	A'S'
	CALL	UAT
	MOVLW	A'S'
	CALL	UAT
	MOVLW	A'I'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT
	MOVF	RSSIH,W
	CALL	UAT
	MOVF	RSSIL,W
	CALL	UAT
	MOVLW	A'd'
	CALL	UAT
	MOVLW	A'B'
	CALL	UAT
	MOVLW	A'm'
	CALL	UAT
	MOVLW	A'*'
	CALL	UAT
	MOVLW	CR
	CALL	UAT
	MOVLW	LF
	CALL	UAT
;
	BCF	WPAGE		;Page0 000h to 7FFh
	CALL	READC_RA0	;    .
	clrf	HEX4
	CLRF	HEX3		;Out: F(ADRESH)
	CLRF	HEX2
	MOVF	ADRESH,W
	MOVWF	HEX1
	bsf	WPAGE		;
	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
	;bcf	WPAGE		;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)

	;bsf	WPAGE		;Page1 800h to FFFh
	MOVLW	A'B'
	CALL	UAT
	MOVLW	A'a'
	CALL	UAT
	MOVLW	A't'
	CALL	UAT
	MOVLW	A't'
	CALL	UAT
	MOVLW	A'e'
	CALL	UAT
	MOVLW	A'r'
	CALL	UAT
	MOVLW	A'y'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT
	MOVF	DEC3,W
	CALL	UAT
	MOVF	DEC2,W
	CALL	UAT
	MOVLW	A','
	CALL	UAT
	MOVF	DEC1,W
	CALL	UAT
	MOVLW	A'V'
	CALL	UAT
	MOVLW	CR
	CALL	UAT
	MOVLW	LF
	CALL	UAT
	BCF	WPAGE		;Page0 000h to 7FFh
;

	BSF	WPAGE		;Page1 800h to FFFh
	MOVLW	A'I'
	CALL	UAT
	MOVLW	A'n'
	CALL	UAT
	MOVLW	A'1'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT

	BCF	WPAGE		;Page0 000h to 7FFh
	MOVLW	EE_InEnable1	;    1.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	BSF	WPAGE		;Page1 800h to FFFh
	CALL	UAT

	MOVLW	A'-'
	CALL	UAT

	MOVLW	A'N'		;   .
	BTFSC	INPUT1		;
	MOVLW	A'A'		;Alarm Active
	CALL	UAT

	MOVLW	A' '
	CALL	UAT
	CALL	UAT
	CALL	UAT

	MOVLW	A'O'
	CALL	UAT
	MOVLW	A'u'
	CALL	UAT
	MOVLW	A't'
	CALL	UAT
	MOVLW	A'1'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT

	BCF	WPAGE		;Page0 000h to 7FFh
	MOVLW	EE_Output1	;   1.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	BSF	WPAGE		;Page1 800h to FFFh
	CALL	UAT

	MOVLW	A' '
	CALL	UAT
	CALL	UAT
	CALL	UAT

	MOVLW	A'G'
	CALL	UAT
	MOVLW	A'P'
	CALL	UAT
	MOVLW	A'S'
	CALL	UAT
	MOVLW	A':'
	CALL	UAT

	BCF	WPAGE		;Page0 000h to 7FFh
	MOVLW	EE_PowerGPS	;   5.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	BSF	WPAGE		;Page1 800h to FFFh
	CALL	UAT

	MOVLW	CR
	CALL	UAT
	MOVLW	LF
	CALL	UAT
	BCF	WPAGE		;Page0 000h to 7FFh
;

NMEA_GSM1			; NMEA-9600bps       GSM-19200bps   
	BSF	WPAGE		;
	CALL	SINC_SOFT	;  UAR!!!
	BCF	WPAGE		;
	BTFSC	SOFT_RX_ERR	;0- SOFT_RX_ERR .
	GOTO	NO_GPS		;1-   .

NMEA_GSM2			;     GSM.
	BSF	WPAGE		;Page1 800h to FFFh
	CALL	UAR_SOFT	;In: NMEA-0183 ASCII	Out:W	b(SOFT_RX_ERR,SOFT_RX_END)
	CALL	UAT		;In: W
	BCF	WPAGE		;Page0 000h to 7FFh

	BTFSC	SOFT_RX_ERR	;1 -     .
	GOTO	NO_GPS		;-> .
	BTFSS	SOFT_RX_END	;1 -  .      .
	GOTO	NMEA_GSM2	;--^

	BTFSC	PIR1,RCIF	;@     GSM. 'ASCII', 'NO CARRIER', ....
	GOTO	DATA_DISCONNECT	;@ -->  !
	GOTO	NMEA_GSM1	;-^
;

NO_GPS
	BSF	WPAGE		;Page1 800h to FFFh
	MOVLW	A'G'		;
	CALL	UAT
	MOVLW	A'P'
	CALL	UAT
	MOVLW	A'S'
	CALL	UAT
	MOVLW	A' '
	CALL	UAT
	MOVLW	A'E'
	CALL	UAT
	MOVLW	A'r'
	CALL	UAT
	MOVLW	A'r'
	CALL	UAT
	MOVLW	A'o'
	CALL	UAT
	MOVLW	A'r'
	CALL	UAT
	MOVLW	0x0D
	CALL	UAT
	MOVLW	0x0A
	CALL	UAT
	BCF	WPAGE		;Page0 000h to 7FFh

	CALL	TIMER		;!
;

DATA_DISCONNECT
	MOVF	RCREG,W		;@   .
	BCF	RCSTA,CREN	;@   .
;

	bsf	WPAGE		;
	bsf	GPSSpeedBIT	;1-   GPS      38400 bps	0 - 9600 bps
	CALL	GPS_SPEED	;   NMEA  9600bps / 38400bps
	bcf	WPAGE		;   Bluetooth  GPS HOLUX GPSlim236
;

	BSF	WPAGE		;
	CALL	DISCONNECT	;
	BCF	WPAGE		;

	GOTO	MAIN		;--^
;**********************************************************************

;***    .       ***
CONFIRM				;In: W
				;    EEPROM.
	;MOVLW	EE_TELNUMx	;In: W (start address EEPROM)
	CALL	READ_NUM	;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6 NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	
	MOVLW	A'0'		;Voice Call
	MOVWF	TYPE_CALL	;

	BSF	WPAGE		;
	CALL	DIAL		;In: F(NUM_1H,NUM_1L,NUM_2H,NUM_2L,NUM_3H,NUM_3L,NUM_4H,NUM_4L,NUM_5H,NUM_5L,NUM_6H,NUM_6L)
	BCF	WPAGE		;In: F(TYPE_CALL)	A'0' - Voice			A'1' - Data
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;.
	BTFSS	WORK_OK		;
	nop			;

	BSF	WPAGE		;
	movlw	.2		; W x 15S  .
	CALL	DIAL_ANSWER	;In: W	Out: WORK_OK = 1 -    .
				;Out: F(TYPE_ANSWER)	A'B' -  	A'N' -   
				;Out: GSM_ErrData = 1 -   .	SM_NoAnswer = 1 -   .
				;    : <  >						WORK_OK = 0
				;       : <  >			WORK_OK = 0
				;     'Power': <  >			WORK_OK = 0
				; : <  >							WORK_OK = 0
				;  : 	<CR><LF>BUSY<CR><LF>					WORK_OK = 1
				;    : <CR><LF>NO_CARRIER<CR><LF>					WORK_OK = 1
	BCF	WPAGE		;  ''    '' !: <CR><LF>NO_CARRIER<CR><LF>	WORK_OK = 1

	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;
	NOP			;
	BTFSS	WORK_OK		;
	GOTO	MAIN		;-->
	GOTO	MAIN		;-->
;**********************************************************************

;***     .    ***
RELEASE
	BSF	WPAGE		;      
	CALL	KEY_UNLOCK	;Out: WORK_OK = 1 -  .
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	GOTO	RELEASE		;--^
;

RELEASE_1			;    EEPROM.
	MOVLW	EE_TELNUM1	;In: W (start address EEPROM)
	CALL	READ_NUM	;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6 NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	
	MOVLW	A'0'		;Voice Call
	MOVWF	TYPE_CALL	;

	BSF	WPAGE		;
	CALL	DIAL		;In: F(NUM_1H,NUM_1L,NUM_2H,NUM_2L,NUM_3H,NUM_3L,NUM_4H,NUM_4L,NUM_5H,NUM_5L,NUM_6H,NUM_6L)
	BCF	WPAGE		;In: F(TYPE_CALL)	A'0' - Voice			A'1' - Data
	BTFSC	GSM_ErrData	;1 - Receive Error
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	NOP			;--^

	BSF	WPAGE		;
	movlw	.2		; W x 15S  .
	CALL	DIAL_ANSWER	;In: W	Out: WORK_OK = 1 -    .
				;Out: F(TYPE_ANSWER)	A'B' -  	A'N' -   
				;Out: GSM_ErrData = 1 -   .	SM_NoAnswer = 1 -   .
				;    : <  >						WORK_OK = 0
				;       : <  >			WORK_OK = 0
				;     'Power': <  >			WORK_OK = 0
				; : <  >							WORK_OK = 0
				;  : 	<CR><LF>BUSY<CR><LF>					WORK_OK = 1
				;    : <CR><LF>NO_CARRIER<CR><LF>					WORK_OK = 1
	BCF	WPAGE		;  ''    '' !: <CR><LF>NO_CARRIER<CR><LF>	WORK_OK = 1

	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;
	NOP			;
	BTFSS	WORK_OK		;
	GOTO	RELEASE_2	;-->

	MOVF	TYPE_ANSWER,W
	SUBLW	A'B'		;BUSY
	BTFSC	STATUS,Z
	GOTO	RELEASE_END	;-->

	MOVF	TYPE_ANSWER,W
	SUBLW	A'N'		;NO_CARRIER
	BTFSC	STATUS,Z
	GOTO	RELEASE_END	;-->

RELEASE_2			;    EEPROM.
	MOVLW	EE_TELNUM2	;In: W (start address EEPROM)
	CALL	READ_NUM	;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6 NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	
	MOVLW	A'0'		;Voice Call
	MOVWF	TYPE_CALL	;

	BSF	WPAGE		;
	CALL	DIAL		;In: F(NUM_1H,NUM_1L,NUM_2H,NUM_2L,NUM_3H,NUM_3L,NUM_4H,NUM_4L,NUM_5H,NUM_5L,NUM_6H,NUM_6L)
	BCF	WPAGE		;In: F(TYPE_CALL)	A'0' - Voice			A'1' - Data
	BTFSC	GSM_ErrData	;1 - Receive Error
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	NOP			;--^

	BSF	WPAGE		;
	movlw	.2		; W x 15S  .
	CALL	DIAL_ANSWER	;In: W	Out: WORK_OK = 1 -    .
				;Out: F(TYPE_ANSWER)	A'B' -  	A'N' -   
				;Out: GSM_ErrData = 1 -   .	SM_NoAnswer = 1 -   .
				;    : <  >						WORK_OK = 0
				;       : <  >			WORK_OK = 0
				;     'Power': <  >			WORK_OK = 0
				; : <  >							WORK_OK = 0
				;  : 	<CR><LF>BUSY<CR><LF>					WORK_OK = 1
				;    : <CR><LF>NO_CARRIER<CR><LF>					WORK_OK = 1
	BCF	WPAGE		;  ''    '' !: <CR><LF>NO_CARRIER<CR><LF>	WORK_OK = 1

	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;-->
	NOP			;-->
	BTFSS	WORK_OK		;
	GOTO	RELEASE_3	;-->

	MOVF	TYPE_ANSWER,W
	SUBLW	A'B'		;BUSY
	BTFSC	STATUS,Z
	GOTO	RELEASE_END	;-->

	MOVF	TYPE_ANSWER,W
	SUBLW	A'N'		;NO_CARRIER
	BTFSC	STATUS,Z
	GOTO	RELEASE_END	;-->

RELEASE_3			;    EEPROM.
	MOVLW	EE_TELNUM3	;In: W (start address EEPROM)
	CALL	READ_NUM	;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6 NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	
	MOVLW	A'0'		;Voice Call
	MOVWF	TYPE_CALL	;

	BSF	WPAGE		;
	CALL	DIAL		;In: F(NUM_1H,NUM_1L,NUM_2H,NUM_2L,NUM_3H,NUM_3L,NUM_4H,NUM_4L,NUM_5H,NUM_5L,NUM_6H,NUM_6L)
	BCF	WPAGE		;In: F(TYPE_CALL)	A'0' - Voice			A'1' - Data
	BTFSC	GSM_ErrData	;1 - Receive Error
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer	;
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;
	NOP			;--^

	BSF	WPAGE		;
	movlw	.2		; W x 15S  .
	CALL	DIAL_ANSWER	;In: W	Out: WORK_OK = 1 -    .
				;Out: F(TYPE_ANSWER)	A'B' -  	A'N' -   
				;Out: GSM_ErrData = 1 -   .	SM_NoAnswer = 1 -   .
				;    : <  >						WORK_OK = 0
				;       : <  >			WORK_OK = 0
				;     'Power': <  >			WORK_OK = 0
				; : <  >							WORK_OK = 0
				;  : 	<CR><LF>BUSY<CR><LF>					WORK_OK = 1
				;    : <CR><LF>NO_CARRIER<CR><LF>					WORK_OK = 1
	BCF	WPAGE		;  ''    '' !: <CR><LF>NO_CARRIER<CR><LF>	WORK_OK = 1

	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;.
	BTFSC	GSM_NoAnswer	;
	NOP			;
	BTFSS	WORK_OK		;
	GOTO	RELEASE_C	;-->

	MOVF	TYPE_ANSWER,W	;
	SUBLW	A'B'		;BUSY
	BTFSC	STATUS,Z	;
	GOTO	RELEASE_END	;-->

	MOVF	TYPE_ANSWER,W	;
	SUBLW	A'N'		;NO_CARRIER
	BTFSC	STATUS,Z	;
	GOTO	RELEASE_END	;-->

RELEASE_C			;
	MOVLW	.120		;
	MOVWF	COUNT		;.120 x 0,5S = 60sec
RELEASE_C1			;
	CALL	TIMER		;0,5S	Use TMR1
	DECFSZ	COUNT,F		;
	GOTO	RELEASE_C1	;-^
	GOTO	RELEASE		;--^
;

RELEASE_END			;   .?
	GOTO	MAIN
;**********************************************************************


;**********************************************************************
SEND_NMEA
	BSF	STATUS,RP0	;
	MOVF	OPTION_REG,W	;   OPTION_REG
	MOVWF	OPTIONMEM	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	IORLW	B'00000001'	;38400bps	8MHz
	;IORLW	B'00000011'	; 9600bps	8MHz
	MOVWF	OPTION_REG	;
	BCF	STATUS,RP0	;

	BSF	WPAGE		;
	bcf	GPSSpeedBIT	;1-   GPS      38400 bps	0 - 9600 bps
	CALL	GPS_SPEED	;   NMEA  38400bps  9600bps
	BCF	WPAGE		;

	BSF	STATUS,RP0	;Bank 1(3)
	MOVF	OPTION_REG,W	;   OPTION_REG
	MOVWF	OPTIONMEM	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	;IORLW	B'00000001'	;38400bps	8MHz
	IORLW	B'00000011'	; 9600bps	8MHz
	MOVWF	OPTION_REG	;
	BCF	STATUS,RP0	;

	CALL	TIMER		;0,5S
	CALL	TIMER		;0,5S
	CALL	TIMER		;0,5S
	CALL	TIMER		;0,5S

	BCF	FSRBANK		;0- FSR (Bank0,1)!!!

	movlw	StartGPS	;Start Address RAM.
	movwf	FSR		;
CLEAR_GPS			;
	movlw	A' '		;
	movwf	INDF		;
	incf	FSR,F		;
	movlw	StartGPS	;
	addlw	LengthGPS	;
	addlw	.1		;
	subwf	FSR,W		;
	btfss	STATUS,C	;
	GOTO	CLEAR_GPS	;

	BSF	WPAGE		;
	CALL	NMEA		;  NMEA    1,5S   . Out: F(.....
	BCF	WPAGE

	;BTFSS	WORK_OK		;
	;NOP			;

	bsf	WPAGE		;
	bsf	LatLngBIT	;1-Translate Lat	0-Translate Lng			X0'00.0000 -> XX.XXX XXX
	CALL	TRASLATE_DEG	;In: F(GPLat....)	Out: F(GPLat....)	9byte	max89.999 999 = 05 5D 4A 7F h
	bcf	LatLngBIT	;1-Translate Lat	0-Translate Lng
	CALL	TRASLATE_DEG	;In: F(GPLng....)	Out: F(GPLng....)	10byte
	;bcf	WPAGE		;

	;bsf	WPAGE		;
	bsf	GPSSpeedBIT	;1-   GPS      38400 bps	0 - 9600 bps
	CALL	GPS_SPEED	;   NMEA  9600bps / 38400bps
	bcf	WPAGE		;

;*********************** SMS************************************
	BSF	WPAGE		;
	CALL	SEND_SMS_START	;   SMS  PDU    
	BCF	WPAGE		;In : SMS Center - EE_SCENTER  EEPROM
				;Out: GSM_ErrData = 1 -   .
				;Out: SM_NoAnswer = 1 -   .
				;Out:WORK_OK = 1 -  .
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;Out: WORK_OK = 1 -        '>'.
	GOTO	MAIN		;-->
;
				;  . In: F( 160  SMS )

	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC5 - DEC1) For F88
				;  GPS    BANK1 !!!
	movlw	A'l'
	MOVWF	ASCII_1
	movlw	A'a'
	MOVWF	ASCII_2
	movlw	A't'
	MOVWF	ASCII_3
	movlw	A':'
	MOVWF	ASCII_4

	movlw	StartGPS	;Start Address RAM.
	addlw	GPLat		;9byte
	movwf	FSR		;1
	MOVF	INDF,W		;
	MOVWF	ASCII_5

	incf	FSR,F		;2
	MOVF	INDF,W
	MOVWF	ASCII_6

	incf	FSR,F		;3
	MOVF	INDF,W
	MOVWF	ASCII_7

	incf	FSR,F		;4
	MOVF	INDF,W
	MOVWF	ASCII_8

	BSF	WPAGE			;1- Work. Page1
	CALL	SEND_SMS_PROGRESS	;In: F(ASCII_1,ASCII_2,ASCII_3,ASCII_4,ASCII_5,ASCII_6,ASCII_7,ASCII_8)	Out: UART (14byte)
	BCF	WPAGE			;0- Work. Page0

	incf	FSR,F		;5
	MOVF	INDF,W
	MOVWF	ASCII_1

	incf	FSR,F		;6
	MOVF	INDF,W
	MOVWF	ASCII_2

	incf	FSR,F		;7
	MOVF	INDF,W
	MOVWF	ASCII_3

	incf	FSR,F		;8
	MOVF	INDF,W
	MOVWF	ASCII_4

	incf	FSR,F		;9
	MOVF	INDF,W
	MOVWF	ASCII_5

	movlw	A' '
	MOVWF	ASCII_6

	movlw	StartGPS	;Start Address RAM.
	addlw	GPLatNS		;
	movwf	FSR		;
	MOVF	INDF,W		;
	MOVWF	ASCII_7

	movlw	A' '
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;2
	BCF	WPAGE			;

	MOVLW	A' '
	MOVWF	ASCII_1
;

	movlw	A'l'
	MOVWF	ASCII_2
	movlw	A'o'
	MOVWF	ASCII_3
	movlw	A'n'
	MOVWF	ASCII_4
	movlw	A'g'
	MOVWF	ASCII_5
	movlw	A':'
	MOVWF	ASCII_6

	movlw	StartGPS	;Start Address RAM.
	addlw	GPLng		;10byte
	movwf	FSR		;1
	MOVF	INDF,W		;
	MOVWF	ASCII_7

	incf	FSR,F		;2
	MOVF	INDF,W
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;3
	BCF	WPAGE			;

	incf	FSR,F		;3
	MOVF	INDF,W
	MOVWF	ASCII_1

	incf	FSR,F		;4
	MOVF	INDF,W
	MOVWF	ASCII_2

	incf	FSR,F		;5
	MOVF	INDF,W
	MOVWF	ASCII_3

	incf	FSR,F		;6
	MOVF	INDF,W
	MOVWF	ASCII_4

	incf	FSR,F		;7
	MOVF	INDF,W
	MOVWF	ASCII_5

	incf	FSR,F		;8
	MOVF	INDF,W
	MOVWF	ASCII_6

	incf	FSR,F		;9
	MOVF	INDF,W
	MOVWF	ASCII_7

	incf	FSR,F		;10
	MOVF	INDF,W
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;4
	BCF	WPAGE			;

	movlw	A' '
	MOVWF	ASCII_1

	movlw	StartGPS	;Start Address RAM.
	addlw	GPLngEW		;
	movwf	FSR		;
	MOVF	INDF,W		;
	MOVWF	ASCII_2

	movlw	A' '
	MOVWF	ASCII_3
	MOVWF	ASCII_4
;

	movlw	A's'
	MOVWF	ASCII_5
	movlw	A'p'
	MOVWF	ASCII_6
	movlw	A'e'
	MOVWF	ASCII_7
	movlw	A'e'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;5
	BCF	WPAGE			;

	movlw	A'd'
	MOVWF	ASCII_1

	movlw	A':'
	MOVWF	ASCII_2
;*******
	movlw	StartGPS	;Start Address RAM.
	addlw	GPSpeed		;
	movwf	FSR		;
	MOVF	INDF,W		;ASCII X00
	MOVWF	DEC3

	incf	FSR,F		;ASCII X00
	MOVF	INDF,W
	MOVWF	DEC2

	incf	FSR,F		;ASCII X00
	MOVF	INDF,W
	MOVWF	DEC1
	CALL	ASCII_HEX	;In: ASCII(DEC3,DEC2,DEC1) 0 - 999	Out: F(HEX2,HEX1)

	clrf	HEX4		;F(HEX2,HEX1) * 1852 / 1000	knot-> km/h
	clrf	HEX3
	clrf	HEXmul4
	clrf	HEXmul3
	MOVLW	0x07		;1852 = 073Ch
	MOVWF	HEXmul2
	MOVLW	0x3C
	MOVWF	HEXmul1
	CALL	MULTIPLIC	;In: F(HEX4,HEX3,HEX2,HEX1) * F(HEXmul4,HEXmul3,HEXmul2,HEXmul1)
				;Out:F(HEX4,HEX3,HEX2,HEX1)
	clrf	HEX4		;  3
	clrf	HEXdel_4
	clrf	HEXdel_3
	MOVLW	0x03		;1000 = 03E8h
	MOVWF	HEXdel_2
	MOVLW	0xE8
	MOVWF	HEXdel_1
	bsf	WPAGE		;
	CALL	DIVISION	;In: F(HEX4,HEX3,HEX2,HEX1) / F(HEXdel_4,HEXdel_3,HEXdel_2,HEXdel_1)
	bcf	WPAGE		;Out:  F(RESULT4,RESULT3,RESULT2,RESULT1)
				;: F(DIV_REG_4,DIV_REG_3,DIV_REG_2,DIV_REG_1)  0  
	clrf	HEX4
	clrf	HEX3
	movf	RESULT2,W
	MOVWF	HEX2
	movf	RESULT1,W
	MOVWF	HEX1
	bsf	WPAGE		;
	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC5 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
	bcf	WPAGE		;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
;*******
	movf	DEC1,W
	MOVWF	ASCII_3

	movf	DEC1,W
	MOVWF	ASCII_4

	movf	DEC1,W
	MOVWF	ASCII_5

	MOVLW	A'k'
	MOVWF	ASCII_6

	MOVLW	A'm'
	MOVWF	ASCII_7

	MOVLW	A'/'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;6
	BCF	WPAGE			;

	MOVLW	A'h'
	MOVWF	ASCII_1

	movlw	CR
	MOVWF	ASCII_2
	movlw	LF
	MOVWF	ASCII_3
;

	MOVLW	A'T'
	MOVWF	ASCII_4
	MOVLW	A':'
	MOVWF	ASCII_5

	movlw	StartGPS	;Start Address RAM.
	addlw	GPData		;
	movwf	FSR		;1
	MOVF	INDF,W		;X0-00-0000
	MOVWF	ASCII_6

	incf	FSR,F		;2
	MOVF	INDF,W		;0X-00-0000
	MOVWF	ASCII_7

	MOVLW	A'/'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;7
	BCF	WPAGE			;

	incf	FSR,F		;3
	MOVF	INDF,W		;00-X0-0000
	MOVWF	ASCII_1

	incf	FSR,F		;4
	MOVF	INDF,W		;00-0X-0000
	MOVWF	ASCII_2

	MOVLW	A'/'
	MOVWF	ASCII_3

	incf	FSR,F		;5
	MOVF	INDF,W		;00-00-20X0
	MOVWF	ASCII_4

	incf	FSR,F		;6
	MOVF	INDF,W		;00-00-200X
	MOVWF	ASCII_5

	movlw	A' '
	MOVWF	ASCII_6
;

	movlw	StartGPS	;Start Address RAM.
	addlw	GPTime		;
	movwf	FSR		;1
	MOVF	INDF,W		;X0:00
	MOVWF	ASCII_7

	incf	FSR,F		;2
	MOVF	INDF,W
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;8
	BCF	WPAGE			;

	movlw	A':'
	MOVWF	ASCII_1

	incf	FSR,F		;3
	MOVF	INDF,W
	MOVWF	ASCII_2

	incf	FSR,F		;4
	MOVF	INDF,W
	MOVWF	ASCII_3

	movlw	CR
	MOVWF	ASCII_4
	movlw	LF
	MOVWF	ASCII_5
;

	movlw	A'I'
	MOVWF	ASCII_6
	movlw	A'n'
	MOVWF	ASCII_7
	movlw	A'1'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;9
	BCF	WPAGE			;

	movlw	A':'
	MOVWF	ASCII_1

	MOVLW	EE_InEnable1	;    1.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	MOVWF	ASCII_2

	movlw	A'-'
	MOVWF	ASCII_3

	MOVLW	A'N'		;   .
	BTFSC	INPUT1		;
	MOVLW	A'A'		;Alarm Active
	MOVWF	ASCII_4

	movlw	A' '
	MOVWF	ASCII_5
;

	movlw	A'O'
	MOVWF	ASCII_6
	movlw	A'u'
	MOVWF	ASCII_7
	movlw	A't'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;10
	BCF	WPAGE			;

	movlw	A'1'
	MOVWF	ASCII_1

	movlw	A':'
	MOVWF	ASCII_2

	MOVLW	EE_Output1	;   1.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	MOVWF	ASCII_3
	
	movlw	A' '
	MOVWF	ASCII_4
;

	movlw	A'G'
	MOVWF	ASCII_5
	movlw	A'P'
	MOVWF	ASCII_6
	movlw	A'S'
	MOVWF	ASCII_7
	movlw	A':'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;11
	BCF	WPAGE			;

	MOVLW	EE_PowerGPS	;   5.
	MOVWF	REEADR		;
	CALL	READE		;'e / d'
	MOVWF	ASCII_1

	movlw	CR
	MOVWF	ASCII_2
	movlw	LF
	MOVWF	ASCII_3
;

	movlw	A'C'
	MOVWF	ASCII_4
	movlw	A'e'
	MOVWF	ASCII_5
	movlw	A'l'
	MOVWF	ASCII_6
	movlw	A'l'
	MOVWF	ASCII_7
	movlw	A'I'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;12
	BCF	WPAGE			;

	movlw	A'D'
	MOVWF	ASCII_1

	movlw	A':'
	MOVWF	ASCII_2

	clrf	HEX4
	CLRF	HEX3		;
	MOVF	CELLH,W
	MOVWF	HEX2
	MOVF	CELLL,W
	MOVWF	HEX1
	bsf	WPAGE		;
	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC4 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
	bcf	WPAGE		;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)
	movf	DEC5,W		;1
	MOVWF	ASCII_3
	movf	DEC4,W		;2
	MOVWF	ASCII_4
	movf	DEC3,W		;3
	MOVWF	ASCII_5
	movf	DEC2,W		;4
	MOVWF	ASCII_6
	movf	DEC1,W		;5
	MOVWF	ASCII_7

	movlw	A' '
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;13
	BCF	WPAGE			;

	movlw	A'L'
	MOVWF	ASCII_1
	movlw	A'e'
	MOVWF	ASCII_2
	movlw	A'v'
	MOVWF	ASCII_3
	movlw	A'e'
	MOVWF	ASCII_4
	movlw	A'l'
	MOVWF	ASCII_5
	movlw	A':'
	MOVWF	ASCII_6
	movf	RSSIH,W		;1
	MOVWF	ASCII_7
	movf	RSSIL,W		;2
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;14
	BCF	WPAGE			;

	movlw	CR
	MOVWF	ASCII_1
	movlw	LF
	MOVWF	ASCII_2
;

	movlw	A'B'
	MOVWF	ASCII_3
	movlw	A'a'
	MOVWF	ASCII_4
	movlw	A't'
	MOVWF	ASCII_5
	movlw	A't'
	MOVWF	ASCII_6
	movlw	A'e'
	MOVWF	ASCII_7
	movlw	A'r'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;15
	BCF	WPAGE			;

	movlw	A'y'
	MOVWF	ASCII_1
	movlw	A':'
	MOVWF	ASCII_2
	

	CALL	READC_RA0	;Out: F(ADRESH)
	clrf	HEX4
	CLRF	HEX3		;   .
	CLRF	HEX2		;
	MOVF	ADRESH,W	;
	MOVWF	HEX1		;
	bsf	WPAGE		;
	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	F(DEC4 - DEC1) For F88
	CALL	HEX_ASCII	;In: F(HEX4,HEX3,HEX2,HEX1)
	bcf	WPAGE		;Out:F(DEC10,DEC9,DEC8,DEC7,DEC6,DEC5,DEC4,DEC3,DEC2,DEC1)

	movf	DEC3,W		;1
	MOVWF	ASCII_3
	movf	DEC2,W		;2
	MOVWF	ASCII_4
	movlw	A','
	MOVWF	ASCII_5
	movf	DEC1,W		;3
	MOVWF	ASCII_6
	movlw	A'V'
	MOVWF	ASCII_7

	movlw	A' '
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;16
	BCF	WPAGE			;

	movlw	CR
	MOVWF	ASCII_1
	movlw	LF
	MOVWF	ASCII_2

	movlw	A'G'
	MOVWF	ASCII_3
	movlw	A'P'
	MOVWF	ASCII_4
	movlw	A'S'
	MOVWF	ASCII_5
	movlw	A'-'
	MOVWF	ASCII_6
	movlw	A'S'
	MOVWF	ASCII_7
	movlw	A't'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;17
	BCF	WPAGE			;

	movlw	A'a'
	MOVWF	ASCII_1
	movlw	A't'
	MOVWF	ASCII_2
	movlw	A'u'
	MOVWF	ASCII_3
	movlw	A's'
	MOVWF	ASCII_4
	movlw	A':'
	MOVWF	ASCII_5

	movlw	StartGPS	;Start Address RAM.
	addlw	GPStat		;
	movwf	FSR		;1
	MOVF	INDF,W		;
	MOVWF	ASCII_6

	movlw	A' '
	MOVWF	ASCII_7
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;18
	BCF	WPAGE			;

	movlw	CR
	MOVWF	ASCII_1
	movlw	LF
	MOVWF	ASCII_2
;

	MOVLW	A'H'
	MOVWF	ASCII_3
	MOVLW	A'e'
	MOVWF	ASCII_4
	MOVLW	A'a'
	MOVWF	ASCII_5
	MOVLW	A'd'
	MOVWF	ASCII_6
	MOVLW	A'i'
	MOVWF	ASCII_7
	MOVLW	A'n'
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;19
	BCF	WPAGE			;

	MOVLW	A'g'
	MOVWF	ASCII_1
	MOVLW	A':'
	MOVWF	ASCII_2

	movlw	StartGPS	;Start Address RAM.
	addlw	GPHeading	;
	movwf	FSR		;1
	MOVF	INDF,W		;X00
	MOVWF	ASCII_3

	incf	FSR,F		;2
	MOVF	INDF,W
	MOVWF	ASCII_4

	incf	FSR,F		;3
	MOVF	INDF,W
	MOVWF	ASCII_5

	MOVLW	'd'		;degree
	MOVWF	ASCII_6

	movlw	' '
	MOVWF	ASCII_7
	MOVWF	ASCII_8

	BSF	WPAGE			;
	CALL	SEND_SMS_PROGRESS	;20
	BCF	WPAGE			;
;

	BSF	WPAGE		;
	CALL	SEND_SMS_END	;
	BCF	WPAGE		;
	BTFSC	GSM_ErrData	;1 -      
	GOTO	NO_GSM		;-->
	BTFSC	GSM_NoAnswer
	GOTO	NO_GSM		;-->
	BTFSS	WORK_OK		;Out: WORK_OK = 1 -  SMS.
	GOTO	MAIN		;--^

	GOTO	MAIN		;--^
;**********************************************************************

;**********************************************************************
NO_GSM
	MOVLW	.205		;  .
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;
	CALL	BEEPER		;

	BCF	POWER_SUPPLY	;   GSM  GPS.

	CALL	TIMER		;
	CALL	TIMER		;
	CALL	TIMER		;
	CALL	TIMER		;
	CALL	TIMER		;

	GOTO	START	;BEGIN	;-->
;**********************************************************************

;**********************************************************************
READ_NUM			;  .
	MOVWF	REEADR		;In: W (start address EEPROM)
	CALL	READE		;Out: F(NUM_1,NUM_2,NUM_3,NUM_4,NUM_5,NUM_6 NUM_7,NUM_8,NUM_9,NUM_10,NUM_11,NUM_12)
	MOVWF	NUM_1

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_2

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_3

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_4

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_5

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_6

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_7

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_8

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_9

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_10

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_11

	INCF	REEADR,F
	CALL	READE
	MOVWF	NUM_12

	RETURN
;**********************************************************************

;**********************************************************************
WRITE_NUM			;In: W (start address EEPROM)
	MOVWF	REEADR
	MOVF	NUM_1,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_2,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_3,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_4,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_5,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_6,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_7,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_8,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_9,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_10,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_11,W
	MOVWF	REEDATA
	CALL	WRITE

	INCF	REEADR,F
	MOVF	NUM_12,W
	MOVWF	REEDATA
	CALL	WRITE

	RETURN
;**********************************************************************

;**********************************************************************
CHECK_NUM			;In: W (start address EEPROM)
	BCF	WORK_OK		;Out: WORK_OK = 1 -  

	MOVWF	REEADR
	CALL	READE
	SUBWF	NUM_1,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_2,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_3,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_4,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_5,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_6,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_7,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_8,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_9,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_10,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_11,W
	BTFSS	STATUS,Z
	RETURN

	INCF	REEADR,F
	CALL	READE
	SUBWF	NUM_12,W
	BTFSS	STATUS,Z
	RETURN

	BSF	WORK_OK		;Out: WORK_OK = 1 -  
	RETURN
;**********************************************************************

;**********************************************************************
TIMER				;0,5S
	CLRF	TMR1L		;Max period 8uS * 65536 = 250mS
	MOVLW	.244		;
	MOVWF	TMR1HMEM	;
	COMF	TMR1HMEM,W	;
	MOVWF	TMR1H		;
	BCF	PIR1,TMR1IF	;
	BTFSS	PIR1,TMR1IF	;
	GOTO	$-1		;Overflow TMR1 -> 

	CLRF	TMR1L		;Max period 8uS * 65536 = 250mS
	MOVLW	.244		;
	MOVWF	TMR1HMEM	;
	COMF	TMR1HMEM,W	;
	MOVWF	TMR1H		;
	BCF	PIR1,TMR1IF	;
	BTFSS	PIR1,TMR1IF	;
	GOTO	$-1		;Overflow TMR1 -> 
	RETURN
;**********************************************************************




;**********************************************************************
WRITE				;In:F(REEADR,REEDATA)
	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	REEADR,W	;
	MOVWF	EEADR

	MOVF	REEDATA,W
	MOVWF	EEDATA

	BSF	STATUS,RP1	;
	BSF	STATUS,RP0	;Bank3

	BCF	EECON1,EEPGD	;0 - Accesses data memory EEPROM

	BCF	INTCONMEM,GIE	;
	BTFSC	INTCON,GIE	;
	BSF	INTCONMEM,GIE	;
	BCF	INTCON,GIE	;

	BSF	EECON1,WREN	;1 - Allows write cycles
	MOVLW	0x55		;
	MOVWF	EECON2		;
	MOVLW	0xAA		;
	MOVWF	EECON2		;
	BSF	EECON1,WR	;1 - initiates a write cycles
WRITE_CH			;
	BTFSC	EECON1,WR       ;0 - Write cycles to the EEPROM is complete
	GOTO	WRITE_CH	;-^
	
	BTFSC	INTCONMEM,GIE	;
	BSF	INTCON,GIE	;

	BCF	EECON1,WREN	;disable write
	BCF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank0
	RETURN
;

READE				;In:F(REEADR)
	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	REEADR,W	;Out:F(REEDATA),W
	MOVWF	EEADR

	BSF	STATUS,RP1	;
	BSF	STATUS,RP0	;Bank3

	BCF	EECON1,EEPGD	;0 - Accesses data memory EEPROM

	BSF	EECON1,RD	;1 - initiates an EEPOM read
READE_CH
	BTFSC	EECON1,RD	;rd done?
	GOTO	READE_CH	;no then loop

	BSF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank2
	MOVF	EEDATA,W
	MOVWF	REEDATA

	BCF	STATUS,RP1	;
	BCF	STATUS,RP0	;Bank0

	RETURN			;
;

READC_RA0			;Analog-to-Digital Converter	Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA0
	BCF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA1			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA1
	BCF	ADCON0,CHS1	;
	BSF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA2			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA2
	BSF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA3			;Out: F(ADRESH)
	BCF	ADCON0,CHS2	;Select A/D Input Chennel: RA3
	BSF	ADCON0,CHS1	;
	BSF	ADCON0,CHS0	;
	GOTO	READC		;

READC_RA4			;Out: F(ADRESH)
	BSF	ADCON0,CHS2	;Select A/D Input Chennel: RA4
	BCF	ADCON0,CHS1	;
	BCF	ADCON0,CHS0	;
	GOTO	READC		;

READC
	BSF	ADCON0,ADON	;1 = A/D converter module is operating
	MOVLW	.20		;.10 Fosc=4MHz	.20 Fosc=8MHz
	MOVWF	ACQT		;Acquisition Time 20uS.
	DECFSZ	ACQT,F		;-
	GOTO	$-1		;-^

	BSF	ADCON0,GO	;Start Convertion
READC_CH			;
	BTFSC	ADCON0,GO	;
	GOTO	READC_CH	;-^
	BCF	ADCON0,ADON	;0 = A/D converter is shut_off
	RETURN			;
;

SET_ADC
	BSF	STATUS,RP0	;Bank1
	MOVWF	ANSEL		;Analog Select Register
	BCF	ADCON1,VCFG1	;A/D Voltage Reference Configuration
	BCF	ADCON1,VCFG0	;
	BCF	ADCON1,ADFM	;X X X X X X X X / x x
	BSF	ADCON1,ADCS2	;
	BCF	STATUS,RP0	;Bank0
	BSF	ADCON0,ADCS1	;Select A/D Conversion Clock IntRC 4uS!!!
	BSF	ADCON0,ADCS0	;-//-
	RETURN
;

SET_OSC				;Oscillator configuration.
	BSF	STATUS,RP0	;Bank1
	MOVWF	OSCCON		;
	BCF	OSCCON,SCS1	;0 - Oscillator Mode Defined By h'2007'
	BCF	OSCCON,SCS0	;0
	MOVLW	OSCTUNE_MNL	;Central frequency
	MOVWF	OSCTUNE		;
	BCF	STATUS,RP0	;Bank0
	RETURN			;
;

SET_TMR0
	BSF	STATUS,RP0	;Bank1
	BCF	OPTION_REG,T0CS	;0 - Intrnal Clock Source
	BTFSC	OPTION_REG,T0CS	;
	BCF	OPTION_REG,T0SE	;0 - Rising Transition RA4

	BCF	OPTION_REG,PSA	;0 - Prescaler Is Assigned To The TMR0 Module
	BTFSC	OPTION_REG,PSA	;
	GOTO	SET_TMR0_1	;-->

	MOVF	OPTION_REG,W	;
	ANDLW	B'11111000'	;  PS2 PS1 PS0
	;IORLW	B'00000000'	;Fosc/4/2	4MHz =>   2uS
	;IORLW	B'00000001'	;Fosc/4/4
	;IORLW	B'00000010'	;Fosc/4/8
	;IORLW	B'00000011'	;Fosc/4/16
	;IORLW	B'00000100'	;Fosc/4/32
	IORLW	B'00000101'	;Fosc/4/64
	;IORLW	B'00000110'	;Fosc/4/128
	;IORLW	B'00000111'	;Fosc/4/256	4MHz => 256uS
	MOVWF	OPTION_REG	;

SET_TMR0_1
	BCF	STATUS,RP0		;Bank0
	RETURN
;

SET_TMR1			;Timer1 Module:	Max period 8uS * 65536 = 524,288mS
	BCF	T1CON,T1RUN	;1 - System clock is derived from Timer1 oscillator
	BSF	T1CON,T1CKPS1	;Timer prescaler /1 - 0   /2 - 0   /4 - 1   /8 - 1
	BSF	T1CON,T1CKPS0	;Timer prescaler      0        1        0        1
	BCF	T1CON,T1OSCEN	;Oscillator is shut off.
	BSF	T1CON,NOT_T1SYNC ;1 - Do not synchronize external clock input
	BCF	T1CON,TMR1CS	;Internal Clock Fosc/4	4MHz = 8uS
	BSF	T1CON,TMR1ON	;Timer1 On bit.
	RETURN
;

SET_PWM				;Reset Pulse Width Modulation
	BSF	STATUS,RP0	;Bank1
	BCF	TRISB,3		;RB3 Output!
	MOVLW	0xFF		;
	MOVWF	PR2		;Period register.
	BCF	STATUS,RP0	;Bank0

	CLRF	CCPR1L		;Bit 9 - 2
	BCF	CCP1CON,CCP1X	;Bit 1
	BCF	CCP1CON,CCP1Y	;Bit 0

	BCF	T2CON,T2CKPS1	;Timer prescaler 1 - 0   4 - 0   16 - 1
	BCF	T2CON,T2CKPS0	;Timer prescaler     0       1        X

	BSF	T2CON,TMR2ON	;Timer2 is ON.

	MOVLW	B'00001100'	;PWM mode.
	MOVWF	CCP1CON		;
	RETURN
;

SET_CVREF
	MOVLW	B'00000000'

	BSF	STATUS,RP0	;Bank1
	MOVWF	CVRCON		;
	BSF	CVRCON,CVRR	;Range
	BSF	CVRCON,CVROE	;Output Enable Bit.
	BSF	CVRCON,CVREN	;Module Enable Bit.
	BCF	STATUS,RP0	;Bank0
	RETURN
;

SET_COMPM
	BSF	STATUS,RP0	;Bank1
	MOVLW	B'00000111'	;I/O Operating Modes.
	MOVWF	CMCON		;
	BCF	CMCON,CIS	;Input Switch Bit.
				;
	BCF	STATUS,RP0	;Bank0
	RETURN			;
;

SET_UART
	BANKSEL	SPBRG
	MOVWF	SPBRG

	BANKSEL	TRISB
	BCF	TRISB,5		;Serial Output
	BSF	TRISB,2		;Serial Input

	BANKSEL	RCSTA		;Receive Status & Control Register
	BSF	RCSTA,SPEN	;1-> Serial Port Enabbled
	BCF	RCSTA,RX9	;0-> 8bit RX	1-> 9bit RX
	;BCF	RCSTA,SREN	;
	BCF	RCSTA,CREN	;		1-> Enables Continuous Receive !!!
	BCF	RCSTA,ADDEN	;Address Detect Enable bit
	;BCF	RCSTA,FERR	;0-> No Framing Error
	;BCF	RCSTA,OERR	;0-> No Overrun Error
	;BCF	RCSTA,RX9D	;9th bit of Receive Data

	BANKSEL	TXSTA		;Trasnit Status & Control Register
	;BCF	TXSTA,CSRC	;
	BCF	TXSTA,TX9	;0-> 8bit TX	1-> 9bit TX
	BSF	TXSTA,TXEN	;0-> Disable	1-> Enable TX
	BCF	TXSTA,SYNC	;0-> Asynchron	1-> Synchronous
	BSF	TXSTA,BRGH	;0-> Low-speed	1-> High-speed
	;BCF	TXSTA,TX9D	;9bit Parity Bit

	BANKSEL	0
	RETURN
;

SET_WDT
	BSF	STATUS,RP0	;Select Bank1.
	MOVLW	B'00010110'	;1:65536
	MOVWF	WDTCON		;
	BCF	WDTCON,SWDTEN	;1 - WDT Is Turned ON (If Configuration Bit=0 disable)
	BCF	STATUS,RP0	;Select Bank0.
	RETURN
;**********************************************************************

;*******   **********************
START
	BCF	STATUS,RP1	;Bank0
	BCF	STATUS,RP0	;

	BCF	FSRBANK		;0- Bank0,1	1- Bank2,3	    FSR.
	BCF	WPAGE		;0- Work. Page0		1- Work. Page1

	CLRF	PORTA
	CLRF	PORTB

	CLRF	INTCON		;  .
	BSF	STATUS,RP0	;Select Bank1.
	CLRF	PIE1
	CLRF	PIE2
	BCF	STATUS,RP0	;Select Bank0.

	;MOVLW	B'01110000'	;Internal oscillator	8MHz
	;MOVLW	B'01100000'	;Internal oscillator	4MHz
	;MOVLW	B'01010000'	;Internal oscillator	2MHz
	;MOVLW	B'01000000'	;Internal oscillator	1MHz
	;MOVLW	B'00110000'	;Internal oscillator	500KHz
	;MOVLW	B'00100000'	;Internal oscillator	250MHz
	;MOVLW	B'00010000'	;Internal oscillator	125MHz
	MOVLW	B'00000000'	;Internal oscillator	31,25KHz
	CALL	SET_OSC		;Oscillator configuration!

	BSF	STATUS,RP0		;Select Bank1.
	BSF	OPTION_REG,NOT_RBPU	;1 - Pull-ups Disabled
	BSF	OPTION_REG,INTEDG	;1 - Rising RB0 Interrupt
	BCF	STATUS,RP0		;Select Bank0.

	MOVLW	B'00000001'	;0- Digital I/O		1- Analog Input
	CALL	SET_ADC		;ADC configuration!

	CALL	SET_TMR0	;

	CALL	SET_TMR1	;

	;CALL	SET_CVREF	;Enable Comparator Voltage Reference Module & Reset - RA2

	CALL	SET_COMPM	;

	CALL	SET_WDT

	BSF	STATUS,RP0	;Select Bank1.
	MOVLW	B'00101011'	;
	MOVWF	TRISA		;PortA
	MOVLW	B'00001100'	;
	MOVWF	TRISB		;PortB
	BCF	STATUS,RP0	;Select Bank0.

	;CALL	SET_PWM		;Enable PWM & Reset - RB3

	;MOVLW	.25		;19200 bps UART	8MHz
	;CALL	SET_UART

	GOTO	BEGIN		;--^

;*******************************Beep***********************************
BeepOSC		EQU	B'00000010'	;Fosc/4/8 = 4uS  8MHz
	#include	<BEEPER_5.asm>	;Use TMR0
;**********************************************************************

;**************** ASCII -> DEC -> HEX********************
	#include	<ASCII3HEX2_1.asm>	;
;**********************************************************************

;******************Multiplication 32bit * 32bit************************
	#include	<MULTIPLIC32_32.asm>	;
;**********************************************************************


;----------------------------------------------------------------------
;	ORG	0x0800				;Page1 !
;----------------------------------------------------------------------


;******************* HEX -> ASCII************************
	ORG	0x0800				;Page1 !
PCLATH_HEX4ASCII7	EQU	.8		; ORG 0x0800 to 0x08FF !!!
	#include	<HEX4bASCII7b_2.asm>	;
;**********************************************************************

;******************* ASCII -> HEX************************
	ORG	0x0818				;Page1 !
PCLATH_ASCIIHEX		EQU	.8		; ORG 0x0800 to 0x08FF !!!
	#include	<ASCII7bHEX4b_3.asm>	;
;**********************************************************************

;**************AT   SIEMENS Fosc=8MHz**********************
	#include	<AT_SIEMENS_18.asm>	;Use TMR1
;**********************************************************************



;*********************   NMEA0183*************************
	ORG	0x0D40			;!
PCLATH_NMEA	EQU	0x0D		; ORG 0x0X00 to 0x0XFF !!!
	#include	<NMEA_9.asm>	; Use TMR0
;**********************************************************************

;******************Software Asynchronous Receiver*********************
					;      .
SinchSoftTime1	EQU	.6		;8MHz	.6 x 0,26S = 1,5S	.4 x 0,26S = 1S	8MHz

					;   'Stop Bit'  'Start Bit'   .
SinchSoftTime2	EQU	0xCF		;200mS -> 3CAF	100mS -> 9E57	50mS ->CF2B	8MHz
	#include	<UART_RX_1.asm>	; Use TMR0,TMR1
;**********************************************************************

;******************Software Asynchronous Transmiter********************
	#include	<UART_TX_1.asm>	; Use TMR0
;**********************************************************************

;********************Division 32bit / 32bit****************************
	#include	<DIVISION32_32.asm>	;
;**********************************************************************

;**************** HEX - >DEC -> ASCII********************
	#include	<HEX4ASCII10_5.asm>	;
;**********************************************************************

;**********Multiplic 32bit * 8bit     **********
	#include	<DEC_HEX32ADD_1.asm>	;
;**********************************************************************

	END